MOUNT_UMAP(8)

NAME
mount_umap - user and group ID remapping file system layer

SYNOPSIS
mount_umap [-i fsid] [-o options] -g gid-mapfile -u uid-mapfile target mount-point

DESCRIPTION
The mount_umap command is used to mount a sub-tree of an existing file system that uses a different set of uids and gids than the local system. Such a file system could be mounted from a remote site via NFS, a local file system on removable media brought from some foreign location that uses a different user/group database, or could be a local file system for another operating system which does not support Unix-style user/group IDs, or which uses a different numbering scheme.

Both target and mount-point are converted to absolute paths before use.

The options are as follows:

-g gid-mapfile
    Use the group ID mapping specified in gid-mapfile. This flag is required.

-i fsid
    Use the specified fsid for the file system ID, rather than choosing one at random. This is useful if the file system is to be exported.

-o  Options are specified with a -o flag followed by a comma separated string of options. See the mount(8) man page for possible options and their meanings.

-u uid-mapfile
    Use the user ID mapping specified in uid-mapfile. This flag is required.

The mount_umap command uses a set of files provided by the user to make correspondences between uids and gids in the sub-tree's original environment and some other set of ids in the local environment. For instance, user smith might have uid 1000 in the original environment, while having uid 2000 in the local environment. The mount_umap command allows the subtree from smith's original environment to be mapped in such a way that all files with owning uid 1000 look like they are actually owned by uid 2000.

target should be the current location of the sub-tree in the local system's name space. mount-point should be a directory where the mapped subtree is to be placed. uid-mapfile and gid-mapfile describe the mappings to be made between identifiers.

The format of the user and group ID mapping files is very simple. The first line of the file is the total number of mappings present in the file. The remaining lines each consist of two numbers: the ID in the mapped subtree and the ID in the original subtree.

For example, to map uid 1000 in the original subtree to uid 2000 in the mapped subtree:

    1
    2000 1000

For user IDs in the original subtree for which no mapping exists, the user ID will be mapped to the user “nobody”. For group IDs in the original subtree for which no mapping exists, the group ID will be mapped to the group “nobody”.

There is a limit of 64 user ID mappings and 16 group ID mappings.

The mapfiles can be located anywhere in the file hierarchy, but they must be owned by root, and they must be writable only by root. mount_umap will refuse to map the sub-tree if the ownership or permissions on these files are improper. It will also report an error if the count of mappings in the first line of the map files is not correct.

SEE ALSO
mount(8), mount_null(8)

HISTORY
The mount_umap utility first appeared in 4.4BSD.

BUGS
The implementation is not very sophisticated.